%define _name gtk+
%define ver_major 2.4
%define binary_ver 2.4.0
%def_disable static

Name: libgtk+2
Version: %ver_major.9
Release: alt1.1

Summary: The GIMP ToolKit (GTK+), a library for creating GUIs for X
Summary(ru_RU.KOI8-R): GTK+,    GUI  X Window System
License: LGPL
Group: System/Libraries
Url: http://www.gtk.org
Packager: Yuri N. Sedunov <aris@altlinux.ru>

Icon: gtk+-logo.xpm
Source: ftp://ftp.gnome.org/pub/gnome/sources/%_name/%ver_major/%_name-%version.tar.bz2
Patch0: gdk-pixbuf-up-bound.patch
Patch1: gtk+-2.4.2-Lai-gtkfilesel.patch.bz2
Patch2: gtk+-2.2.4-Lai-images_types-2004.04.04.patch.gz

%def_disable static
%define glib_ver 2.4.4-alt1.1
%define pango_ver 1.4.0
%define atk_ver 1.6.1
%define xft_ver 2.0-alt5
%define fontconfig_ver 2.2.1-alt2
%define shared_mime_info_ver 0.13

# We need to prereq these so we can run gtk-query-immodules-2.0 in post
PreReq: glib2 >= %glib_ver
PreReq: libpango >= %pango_ver
PreReq: libatk >= %atk_ver
PreReq: XFree86-libs

Requires: common-licenses
Requires: shared-mime-info >= %shared_mime_info_ver

# some fonts with Xft2 support require
Requires: urw-fonts >= 2.0-alt19

Provides: gtk2 = %version, gtk+2 = %version, libgtk2 = %version
Obsoletes: gtk2, gtk+-gtkbeta, gtk+2, libgtk2

BuildPrereq: glib2-devel >= %glib_ver
BuildPrereq: libpango-devel >= %pango_ver
BuildPrereq: libatk-devel >= %atk_ver
#BuildPreReq: libXft-devel >= %xft_ver
BuildPreReq: libXft-devel
BuildPreReq: fontconfig-devel >= %fontconfig_ver

# Automatically added by buildreq on Fri Apr 30 2004 (-bi)
BuildRequires: XFree86-devel common-licenses docbook-utils fontconfig-devel freetype2-devel gcc-c++ gcc-g77 glib2-devel indent libatk-devel libjpeg-devel libpango-devel libpng-devel libstdc++-devel libtiff-devel pkgconfig swfdec-gdk-pixbuf-loaders zlib-devel

%description
GTK+ is a multi-platform toolkit for creating graphical user interfaces.
Offering a complete set of widgets, GTK+ is suitable for projects
ranging from small one-off projects to complete application suites.

This version of GTK+ is required for Gnome 2.x.

%package devel
Summary: Development tools for GTK+ applications
Summary(ru_RU.KOI8-R):    ,  GTK+
Group: Development/GNOME and GTK+
Icon: gtk+-devel-logo.xpm
Requires: %name = %version-%release, glib2-devel >= %glib_ver, pkgconfig
Requires: libatk-devel >= %atk_ver, libpango-devel >= %pango_ver
Provides: gtk2-devel = %version, gtk+2-devel = %version, libgtk2-devel = %version, libgtk+2-devel-static
Obsoletes: gtk2-devel, gtk+-gtkbeta-devel, gtk+2-devel, libgtk2-devel, libgtk+2-devel-static

%description devel
GTK+ is a multi-platform toolkit for creating graphical user interfaces.
This package contains the files needed for developing GTK+ applications.

%if_with static
%package devel-static
Summary: Static libraries for GTK+ (GIMP ToolKit) applications
Group: Development/GNOME and GTK+
Requires: %name = %version-%release
Provides: gtk2-devel-static = %version, gtk+2-devel-static = %version, libgtk2-devel-static = %version
Obsoletes: gtk2-devel, gtk+-gtkbeta-devel, gtk+2-devel, libgtk2-devel

%description devel-static
GTK+ is a multi-platform toolkit for creating graphical user interfaces.
This package contains the static libraries for GTK+.

%endif

%prep
%setup -q -n %_name-%version
%patch0 -p0
%patch1 -p1
%patch2 -p1

%build
%{?_disable_static:export lt_cv_prog_cc_static_works=no}
%{?_enable_static:export lt_cv_prog_cc_static_works=yes}
%configure \
    %{subst_enable static} \
	--with-xinput=yes \
	--enable-fbmanager

# SMP-incompatible build
%make

%install
%makeinstall
%__install -d %buildroot{%_sysconfdir/gtk-2.0,%_libdir/gtk-2.0/%binary_ver/engines}

# system wide gtkrc
%__cat <<__RC__ > %buildroot%_sysconfdir/gtk-2.0/gtkrc
# This enables editing of menu accelerators by pressing
# an accelerator over the menu item.
gtk-can-change-accels = 1
__RC__

# The license
%__ln_s -f %_licensedir/LGPL-2 COPYING

# remove non-packaged files
%__rm -f %buildroot%_libdir/gtk-2.0/*/*/*.la

%find_lang --output=gtk20.lang gtk20 gtk20-properties

# --------------------------------------------------------------------------------------
# needed for Lai's GTK+ File Selector patch
%__cat <<__SH__ >%_name.sh
# Some features of enhanced file selector have performance penalties.
# Here are some environment variables to disable them.

# Disable looking up icons for files.
export GTK_FILESEL_NO_ICONS=1
# Disable file type detection. This will also disable icons.
export GTK_FILESEL_NO_MIME=1
# Disable all columns (Date, Size, etc.) except File.
# This will disable icon lookup and file type detection too.
export GTK_FILESEL_SIMPLE=0
__SH__

%__cat <<__CSH__ >%_name.csh
# Some features of enhanced file selector have performance penalties.
# Here are some environment variables to disable them.

# Disable looking up icons for files.
setenv GTK_FILESEL_NO_ICONS 1
# Disable file type detection. This will also disable icons.
setenv GTK_FILESEL_NO_MIME 1
# Disable all columns (Date, Size, etc.) except File.
# This will disable icon lookup and file type detection too.
setenv GTK_FILESEL_SIMPLE 0
__CSH__

%__install -pD -m755 %_name.sh %buildroot%_sysconfdir/profile.d/%_name.sh
%__install -pD -m755 %_name.csh %buildroot%_sysconfdir/profile.d/%_name.csh
#----------------------------------------------------------------------------------------

%post
%post_ldconfig
%_bindir/gtk-query-immodules-2.0 > %_sysconfdir/gtk-2.0/gtk.immodules
%_bindir/gdk-pixbuf-query-loaders > %_sysconfdir/gtk-2.0/gdk-pixbuf.loaders

%postun -p %postun_ldconfig

%triggerpostun -- %name <= 2.0.6-alt0.7
[ $2 != 0 ] || exit 0
%_bindir/gtk-query-immodules-2.0 > %_sysconfdir/gtk-2.0/gtk.immodules

%files -f gtk20.lang
%_bindir/gtk-query-immodules-2.0
%_bindir/gdk-pixbuf-query-loaders
#%_bindir/gxid
%_libdir/libgtk*.so.*
%_libdir/libgdk*.so.*
%dir %_libdir/gtk-2.0
%dir %_libdir/gtk-2.0/%binary_ver
%dir %_libdir/gtk-2.0/%binary_ver/*
%_libdir/gtk-2.0/%binary_ver/*/*.so
%_datadir/themes
%dir %_sysconfdir/gtk-2.0
#---------------------------------
# needed for Lai's GTK+ File Selector patch
%config %_sysconfdir/profile.d/*
#---------------------------------
%config(noreplace) %_sysconfdir/gtk-2.0/gtkrc
%ghost %_sysconfdir/gtk-2.0/gtk.immodules
%ghost %_sysconfdir/gtk-2.0/gdk-pixbuf.loaders
%_man1dir/gdk-pixbuf-query-loaders.*
%_man1dir/gtk-query-immodules*
%doc --no-dereference COPYING
%doc AUTHORS ChangeLog NEWS README

%files devel
%_bindir/gdk-pixbuf-csource
%_bindir/gtk-demo
%_libdir/*.so
%_libdir/gtk-2.0/include
%_libdir/pkgconfig/*
%_includedir/*
%_datadir/gtk-2.0
%_datadir/aclocal/*
%_datadir/gtk-doc/html/*
%_man1dir/gdk-pixbuf-csource*

%if_enabled static
%files devel-static
%_libdir/*.a
%_libdir/gtk-2.0/*/*/*.a
%endif

%changelog
* Fri Sep 03 2004 Dmitry V. Levin <ldv@altlinux.org> 2.4.9-alt1.1
- Fixed few potential overflows (CAN-2004-0782, CAN-2004-0783),
  patch from Matthias Clasen (RH).

* Thu Aug 26 2004 Yuri N. Sedunov <aris@altlinux.ru> 2.4.9-alt1
- 2.4.9

* Sun Jul 11 2004 Yuri N. Sedunov <aris@altlinux.ru> 2.4.4-alt1
- 2.4.4

* Mon Jun 21 2004 Yuri N. Sedunov <aris@altlinux.ru> 2.4.3-alt1.1
- fix #5547.

* Thu Jun 17 2004 Yuri N. Sedunov <aris@altlinux.ru> 2.4.3-alt1
- 2.4.3

* Sat Jun 05 2004 Yuri N. Sedunov <aris@altlinux.ru> 2.4.2-alt1
- 2.4.2
- Lai-gtkfilesel patch adopted, as usual, by Alexey Morozov.

* Fri Apr 30 2004 Yuri N. Sedunov <aris@altlinux.ru> 2.4.1-alt1
- 2.4.1

* Tue Apr 27 2004 Yuri N. Sedunov <aris@altlinux.ru> 2.4.0-alt1.1
- Applied Lai's GTK+ File Selector patch for 2.2.4 to 2.4.0 (Alexey Morozov)

* Wed Mar 17 2004 Yuri N. Sedunov <aris@altlinux.ru> 2.4.0-alt1
- 2.4.0

* Tue Mar 09 2004 Yuri N. Sedunov <aris@altlinux.ru> 2.3.6-alt1
- 2.3.6
- prereqs XFree86-libs (close #3795).

* Wed Mar 03 2004 Yuri N. Sedunov <aris@altlinux.ru> 2.3.5-alt1
- 2.3.5

* Wed Feb 25 2004 Yuri N. Sedunov <aris@altlinux.ru> 2.3.4-alt1
- 2.3.4

* Fri Jan 23 2004 Yuri N. Sedunov <aris@altlinux.ru> 2.3.2-alt1
- 2.3.2

* Wed Dec 31 2003 Yuri N. Sedunov <aris@altlinux.ru> 2.3.1-alt1
- 2.3.1

* Sun Nov 30 2003 Yuri N. Sedunov <aris@altlinux.ru> 2.2.4-alt4
- do not package .la files.
- remove fileselector patch. Some software on some systems crashes with it.

* Fri Nov 21 2003 Yuri N. Sedunov <aris@altlinux.ru> 2.2.4-alt3
- Enhanced file selector patch
  (http://members1.chello.nl/~h.lai/gtkenhancements/).
- /etc/profile.d/gtk+.{sh,csh} setup some environment variables
   to tune fileselector.

* Mon Oct 20 2003 Rider <rider@altlinux.ru> 2.2.4-alt2
- removed val-ttf bad requires

* Thu Sep 04 2003 Yuri N. Sedunov <aris@altlinux.ru> 2.2.4-alt1
- 2.2.4

* Wed Aug 27 2003 Yuri N. Sedunov <aris@altlinux.ru> 2.2.3-alt1
- 2.2.3

* Tue Jun 10 2003 Yuri N. Sedunov <aris@altlinux.ru> 2.2.2-alt1
- 2.2.2
- Updated descriptions and summaries (mhz).

* Mon Feb 03 2003 Yuri N. Sedunov <aris@altlinux.ru> 2.2.1-alt1
- 2.2.1

* Sat Dec 21 2002 Yuri N. Sedunov <aris@altlinux.ru> 2.2.0-alt1
- 2.2.0

* Tue Dec 17 2002 Yuri N. Sedunov <aris@altlinux.ru> 2.1.5-alt1
- 2.1.5

* Thu Dec 12 2002 Yuri N. Sedunov <aris@altlinux.ru> 2.1.4-alt0.5
- 2.1.4

* Wed Dec 04 2002 Yuri N. Sedunov <aris@altlinux.ru> 2.1.3-alt0.5
- 2.1.3

* Sun Nov 03 2002 Yuri N. Sedunov <aris@altlinux.ru> 2.1.2-alt0.5
- 2.1.2

* Tue Oct 22 2002 Yuri N. Sedunov <aris@altlinux.ru> 2.1.1-alt0.6
- 2.1.1
- build section fixed (SMP-incompatible build).
- Run gdk-pixbuf-query-loaders in %%post
- Editing of menu accelerators enabled by default.
- %_libdir/gtk-2.0/%%binary_ver/engines directory owned by %name.

* Wed Oct 02 2002 Yuri N. Sedunov <aris@altlinux.ru> 2.1.0-alt0.5
- 2.1.0 with Xft2 support.
- some RH patches removed (in mainstream now)

* Tue Oct 01 2002 Yuri N. Sedunov <aris@altlinux.ru> 2.0.6-alt0.8
- lib{pango,atk}-devel added to %name-devel requires list (#1233).
- Some RH patches.

* Sun Sep 15 2002 Yuri N. Sedunov <aris@altlinux.ru> 2.0.6-alt0.7
- 2.06
- fixed-ltmain.sh removed, not needed more.
- changed --with-xinput=yes to --with-xinput=xfree.
- post/postun scripts improved.
- cleanups.

* Sun Jun 16 2002 Igor Androsov <blake@altlinux.ru> 2.0.5-alt1
- New version
- Added ru summary
- man moved to devel package
- Added gxid daemon to package

* Tue Jun 04 2002 Igor Androsov <blake@altlinux.ru> 2.0.3-alt2.1
- Moved *.la from static to devel package
- Fix changelog of <Wed May 29 2002>
- Removed libgtk+2-devel-static, in current time GTK+ disabled static build
- Fix BuildRequires list

* Wed May 29 2002 Igor Androsov <blake@altlinux.ru> 2.0.3-alt2
- Added from AEN package "fixed-ltmain.sh" - fix not building package if host wheare building not hace libgtk+2-devel.

* Wed May 29 2002 Igor Androsov <blake@altlinux.ru> 2.0.3-alt1
- New Release

* Wed May 22 2002 Igor Androsov <blake@altlinux.ru> 2.0.2-alt1
- New version
- Change SPEC, based on AEN spec
- No test program in rpm
- Buildrequires by buldreq

